#!/usr/bin/perl
#   Copyright (c) 2005, Applied Security, Inc.
#   Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com
#
#   This file is part of GPF.
#
#   GPF is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   CmdLine is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with GPF; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#Intended to be a cool extension to GPF.  Say we have a capture, like an smtp email exchange.  We want to fuzz smtp, but we don't have complete captures and don't feel like writing a smtp fuzzer.  Wouldn't it be cool if we had a superGPF that would take a text file of valid smtp commands and than just sorta shuffel them into the capture we already have -- and just go nuts with it?  Rock on.

####
#Start with file creation (file fuzzing really).  Take original capture and create a bunch of new (semi-invalid) ones
####
#User Defined Args
$fileFuzz=1; #fuzzs files
$attack=1; #fuzz using those files - set either to 0 if undesired
$rmAll=1; #WARNING - removes all files from newFilesHome
$newFilesHome="./imap/superGPF/";  #This directory must exist already!!
$filesToCreate=1000;
$captureFile="./imap/long_session.gpf";
$insertFile="./imap/imapCommands.txt";
$modify="C"; #S=server, C=client
$opposite="S"; #This must be the opposite of the above choice!
$spaces=.50; #Chance of spaces for block add/mod
$linefeed=.50; #Chance of \r\n for block modification
#Random percentages for fuzzy file creation
$newBlock=.14; #inserts a totaly new block/line that was never in orginal capture
$newBlockRead=.38; #adds a read to catch possible response from that
$modBlock=.50; #for each, change exisiting block/line in someway
$multiple=.33; #loop over adding stuff
$i1=.63; #add something from #1 group
$i2=.28; #add something from #2 group
$i3=.28; #add something from #3 group

if ($fileFuzz == 1)
{
 #####rm files
 if ($rmAll == 1) {
	system("rm -f ".$newFilesHome."1*");
	system("rm -f ".$newFilesHome."2*");
	system("rm -f ".$newFilesHome."3*");
	system("rm -f ".$newFilesHome."4*");
	system("rm -f ".$newFilesHome."5*");
	system("rm -f ".$newFilesHome."6*");
	system("rm -f ".$newFilesHome."7*");
	system("rm -f ".$newFilesHome."8*");
	system("rm -f ".$newFilesHome."9*");
	system("rm -f ".$newFilesHome."0*");
	sleep 1;
 }
 #####Open and parse files of interest
 if (!open(CAPFILE, $captureFile)){
	die "Couldn't open capture $captureFile: $!\n";}
 if (!open(INSERTFILE, $insertFile)){
	die "Couldn't open capture $captureFile: $!\n";}
 #read in capture file
 $captureLen=read(CAPFILE, $captureData, 100000);
 #close file
 if (!close(CAPFILE)){
	die "Couldn't close capture file: $!\n";}
 #parse capture file
 $numLines=0;
 $position=0;
 while (1){
	#add to position and be sure it's not beyond the end of capdata
	$position+=7;
	if ($position > $captureLen) {
		last; }
	#find client or server
	@source[$numLines]=substr($captureData, $position, 1);
	#add to position and be sure it's not beyond the end of capdata
	$position+=7;
	if ($position > $captureLen) {
		last; }
	#find size
	@size[$numLines]=substr($captureData, $position, 4);
	#add to position and be sure it's not beyond the end of capdata
	$position+=10;
	if ($position > $captureLen) {
		last; }
	#get data
	@data[$numLines]=substr($captureData, $position, @size[$numLines]);
	#update position
	$position+=@size[$numLines];
	if ($position > $captureLen) {
		last; }
	#inc line
	$numLines++;
 }
 #parse insert data
 #Can we do something here with printing to pick up real hex if so desired?
 #Or that could be done in the actual file fuzzing
 $insert=1;
 $i=0;
 LINE: while (<INSERTFILE>){
	chomp;
	if( substr($_,0, 2) eq "#1"){
		next LINE;}
	if ($insert==1){
		if( substr($_,0, 2) eq "#2"){
			$insert=2; $i=0; next LINE;}
		@insert1[$i]=$_;
	}
	if ($insert==2){
		if( substr($_,0, 2) eq "#3"){
			$insert=3; $i=0; next LINE;}
		@insert2[$i]=$_;
	}
	if ($insert==3){
		@insert3[$i]=$_;
	}
	$i++;
 }
 $insert1Len=@insert1;
 $insert2Len=@insert2;
 $insert3Len=@insert3;
 #close file
 if (!close(INSERTFILE)){
	die "Couldn't close insert file: $!\n";}

 #####Open new file(s) (start at 0). fill with good or "fuzzy" capture data.
 #####This is the file fuzzing
 print "Performing file generation.\n";
 for($i=0;$i<$filesToCreate;$i++)
 {
	if (!open(NEWFILE, '>',$newFilesHome . $i) ){
		die "Couldn't open new file: $!\n";}
	for($j=0; $j<$numLines; $j++)
	{
		#possibly add a new blocK
		if ( rand() < $newBlock){
			if (rand() < $multiple){ $times=int(rand(10)); }
			else { $times=1; }
			$dataBuf="";
			for($k=0; $k<$times; $k++)
			{
				if ( rand() < $i1){
					$newBuf=( @insert1[int(rand($insert1Len))] );
					Insert();
				}	
				if ( rand() < $i2){
					$newBuf=( @insert2[int(rand($insert2Len))] );
					Insert();
				}
				if ( rand() < $i3){
					$newBuf=( @insert3[int(rand($insert3Len))] );
					Insert();
				}
			}
			print NEWFILE "Source:$modify Size:" . length($dataBuf) . " Data:$dataBuf";
			if( rand() < $newBlockRead){
				print NEWFILE "Source:$opposite Size:5 Data:Blah\n";
			}
		}	
		#possibly modify an existing block
		if (@source[$j] eq $modify)
		{
			if ( rand() < $modBlock)
			{
				$sizeInc=0;
				if (rand() < $multiple){ $times=int(rand(6)); }
				else { $times=1; }
				$dataBuf=@data[$j];
				for($k=0; $k<$times; $k++)
				{
					if ( rand() < $i1){
						$newBuf=( @insert1[int(rand($insert1Len))] );
						Insert();
					}	
					if ( rand() < $i2){
						$newBuf=( @insert2[int(rand($insert2Len))] );
						Insert();
					}
					if ( rand() < $i3){
						$newBuf=( @insert3[int(rand($insert3Len))] );
						Insert();
					}
				}
				$newSize=@size[$j]+$sizeInc;
				print NEWFILE "Source:@source[$j] Size:$newSize Data:$dataBuf";
			}
			else {	
			print NEWFILE "Source:@source[$j] Size:@size[$j] Data:@data[$j]";
			}
		}
		#put in what it was
		else{
			print NEWFILE "Source:@source[$j] Size:@size[$j] Data:@data[$j]";
		}
	}
	if (!close(NEWFILE)){
		die "Couldn't close newly created file: $!\n";}
 }
 print "File generation Complete.\n";
}

####
#Let the gpf fuzzing begin.  Using the newly created capture files, start launching GPF with random args.
####
#User Defined Args
$target="192.168.31.100";
$port="143";
$proto="TCP";
$SEED=""; #if "" pick random one
$DELAY=""; #if "" pick random one
$LSTART=""; #if "" pick random one
$LSTOP=""; #if "" pick random one
$PSTART=""; #if "" pick random one
$PSTOP=""; #if "" pick random one
$ASTART=""; #if "" pick random one
$AINC=""; #if "" pick random one
$ASTOP=""; #if "" pick random one 
$ACHAR=""; #if "" pick random one
$pc="2";
$userFunc="none";
$CYCLEMODE=""; #if "" pick random one
$READWAIT=""; #if "" pick random one 
$ATTACKMODE=""; #if "" pick random one
$delim="\" \"";
$delimLen="1";
$waitTime=100; #sleep between loops
#precentages
$normalLineStart=.90;
$normalLineStop=.90;
$normalPositionStart=.90;
$normalPositionStop=.90;

if ($attack == 1)
{
 print "Begin fuzzing using new files.\n";
 #loop: make one system call to gpf for each file
 for($i=0; $i<$filesToCreate; $i++)
 {
	if ($modify eq "C"){
		$replayMode=0;
	}
	else {
		$replayMode=1;
	}
	if( $SEED eq "") {
		$seed=int(rand(10000000));
	}
	else { $seed=$SEED; }
	if( $DELAY eq "") {
		$delay=int(rand(14000));
	}
	else { $delay=$DELAY; }
	if( $CYCLEMODE eq "") {
		if( rand() < .65) {
			$cycleMode="1";}
		else {
			$cycleMode="0"; }
	}
	if( $READWAIT eq "") {
		if( rand() < .85) {
			$readWait="3";}
		else {
			$readWait=int(rand(15)); }
	}
	if ($LSTART eq "") {
		if( rand() < $normalLineStart){
			$lstart="0"; }
		else {
			$lstart= int(rand(@data));
			if ($lstart eq @data) {
				$lstart--;}
		}
	}
	else { $lstart=$LSTART; }
	if ($LSTOP eq "") {
		if( rand() < $normalLineStop){
			$lstop="+"; }
		else {
			$lstop= int(rand(@data))+2; 
			if ($lstop <= $lstart){
			$lstop = $lstart + 1; }
		}
	}
	else { $lstop=$LSTOP; }
	if ($PSTART eq "") {
		if( rand() < $normalPositionStart){
			$pstart="0"; }
		else {
			$line= int(rand(@data));
			$pstart= int(rand(@size[$line]));
			if ($pstart eq @size[$line]) {
				$pstart=$pstart-4;}
		}
	}
	else { $pstart=$PSTART; }
	if ($PSTOP eq "") {
		if( rand() < $normalPositionStop){
			$pstop="+"; }
		else {
			$line= int(rand(@data));
			$pstop= int(rand(@size[$line]))+3;
			if ($pstop <= $pstart){
				$pstop = $pstart + 4; }
		}
	}
	else { $pstop=$PSTOP; }
	if( $ATTACKMODE eq "") {
		if( ($x=rand()) < .40) {
			$attackMode="-G b";
			if( ($y=rand()) < 15) {
				if( $ASTART eq "") {
					 $astart=int(rand(1000))+1; }		
				if( $AINC eq "") {
					 $ainc=int(rand(12000))+1; }		
				if( $ASTOP eq "") {
					 $astop=int(rand(95000))+8001; }
			}
			elsif ($y < 85 {
				if( $ASTART eq "") {
					 $astart=int(rand(100))+21; }		
				if( $AINC eq "") {
					 $ainc=int(rand(300))+67; }		
				if( $ASTOP eq "") {
					 $astop=int(rand(4600))+101; }
			}
			else {
				if( $ASTART eq "") {
					 $astart=int(rand(10))+1; }		
				if( $AINC eq "") {
					 $ainc=1; }		
				if( $ASTOP eq "") {
					 $astop=int(rand(99))+1; }
			}
			if( $ACHAR eq "") {
				if( rand() < .80) {
					$a=int(rand(0xff));
					$achar=sprintf("%x", $a); }
				else {
					$achar="43" }
			}
		}
		elsif( $x < .80) {
			$attackMode="-G l";
			if( $ASTART eq "") {
				 $astart=0; }		
			if( $AINC eq "") {
				 $ainc=1; }		
			if( $ASTOP eq "") {
				 $astop=int(rand(1000)); }
			if( $ACHAR eq "") {
				if( rand() < .75) {
					$achar="41"; }
				else {
					$achar="43"; }
			}
		}
		else {
			$attackMode="-G f";
			if( rand() < .97) {
				if( $ASTART eq "") {
					 $astart=int(rand(5))+1; }		
				if( $AINC eq "") {
					 $ainc=int(rand(8))+1; }		
				if( $ASTOP eq "") {
					 $astop=int(rand(100))+9; }
			}
			else {
				if( $ASTART eq "") {
					 $astart=int(rand(100))+1; }		
				if( $AINC eq "") {
					 $ainc=int(rand(1000))+1; }		
				if( $ASTOP eq "") {
					 $astop=int(rand(19000))+1001; }
			}
			if( $ACHAR eq "") {
				if( rand() < .75) {
					$achar="6e"; }
				else {
					$achar="43"; }
			}
		}
	}
	
   #do -P	
   if( ($x=rand()) < .50)
   {
	$attackMode="-P";
	$p_gpf="./GPF ".$newFilesHome.$i." 0 ".$replayMode." ".$target." ".$port." ".$proto." ".$seed." ".$delay." ".$pc." ".$userFunc." ".$readWait." ".$delim." ".$delimLen." ".$attackMode;
	$gpf="./GPF ".$newFilesHome.$i." 0 ".$replayMode." ".$target." ".$port." ".$proto." ".$seed." ".$delay." ".$pc." ".$userFunc." ".$readWait." ".$delim." ".$delimLen." ".$attackMode." >> ".$newFilesHome.$i."_GPF"." 2>&1 &";
   }
   #do -G
   elsif( $x < .99) 
   {
	$p_gpf="./GPF ".$newFilesHome.$i." 0 ".$replayMode." ".$target." ".$port." ".$proto." ".$seed." ".$delay." ".$lstart." ".$lstop." ".$pstart." ".$pstop." ".$astart." ".$ainc." ".$astop." ".$achar." ".$pc." ".$userFunc." ".$cycleMode." ".$readWait." ".$attackMode;
	$gpf="./GPF ".$newFilesHome.$i." 0 ".$replayMode." ".$target." ".$port." ".$proto." ".$seed." ".$delay." ".$lstart." ".$lstop." ".$pstart." ".$pstop." ".$astart." ".$ainc." ".$astop." ".$achar." ".$pc." ".$userFunc." ".$cycleMode." ".$readWait." ".$attackMode." >> ".$newFilesHome.$i."_GPF"." 2>&1 &";
   }
   #do -R
   else
   {
	$delay="900000";
	$attackMode="-R +";
	$p_gpf="./GPF ".$target." ".$port." ".$proto." ".$seed." ".$delay." ".$attackMode;
	$gpf="./GPF ".$target." ".$port." ".$proto." ".$seed." ".$delay." ".$attackMode." >> ".$newFilesHome.$i."_GPF"." 2>&1 &";
   }

       	#uncomment this and comment three below for testing 
	#system("echo \"".$gpf."\n\" >> ./GPF.txt");
        system("echo \""."Command generated:\n".$gpf."\n\" > ".$newFilesHome.$i."_GPF");
	print "[$i] $p_gpf\n";
        system $gpf;
	if ($i > 15) {
        sleep $waitTime; }
 }
 print "SuperGPF complete.\n";
}

###sub for file fuzzing
sub Insert
{
	$sizeInc+=length($newBuf);
	$lineOffset=int(rand(length($dataBuf)));	
	$str1=substr($dataBuf,0, $lineOffset);
	$str2=substr($dataBuf, $lineOffset);

	if(rand() < $spaces){
		if( ($x=rand()) < .34){
			$newBuf=" ".$newBuf." ";
			$sizeInc+=2;
		}
		elsif ($x < .66) {
			if (rand() < .5) {
			$newBuf=$newBuf." ";
			$sizeInc+=1;
			}
		}
		else {
			$newBuf=" ".$newBuf;
			$sizeInc+=1;
		}
	}
	if(rand() < $linefeed) {
		$feed=int(rand(3));
		if ($feed == 0) {
			$feed="\r"; $sizeInc+=1;}
		elsif ($feed == 1) {
			$feed="\r\n"; $sizeInc+=2;}
		elsif ($feed == 2) {
			$feed="\n"; $sizeInc+=1;}
		elsif ($feed == 3) {
			$feed="\n\r"; $sizeInc+=2;}
		if( rand() < .5){
			$newBuf=$newBuf.$feed;
		}
		else{
			$newBuf=$feed.$newBuf;
		}
	}
	
	$dataBuf=$str1 . $newBuf . $str2;
}
