/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CmdLine is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*requires:
stdlib.h
*/
/*comments:
-trying to find an easy way to get solid randomness
-one and two are the same code
-three is said to be weak
*/

/*
//one
u_int RAND(u_int RANGE)
{
	u_int x;

	do {
	    x = rand();
	} while (x >= RANGE * (RAND_MAX/RANGE));
	x /= (RAND_MAX/RANGE);
	
	return x;
}
*/

//two
#define RAND_INV_RANGE(r) (RAND_MAX / (r))
int RAND(int RANGE)
{
	int x=0;

	do {
	    x = rand();
	} while (x >= (RANGE * (RAND_INV_RANGE(RANGE))) );
	x /= (RAND_INV_RANGE(RANGE));
	
	return x;
}

/*
//three
//Not very random
u_int RAND(u_int RANGE)
{
	u_int x;
	
	x = rand()%RANGE;
	
	return x;
}
*/
