/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CmdLine is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

random_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("Random fuzzing Mode (-R +|x-y)\n");
printf("Usage: GPF <hostname/IP> <PORT> <TCP/UDP> <SEED> <DELAY> <ModeArgs>\n");
     printf("\tIP = IP address of target [localhost]\n");
     printf("\tPORT = Destination port [21]\n");
     printf("\tTCP/UDP = Protocol type [TCP]\n");
     printf("\tSEED = Any string of numbers (Allows a successful attack to be repeated) [82645286]\n");
     printf("\tDELAY = Any number of microseconds [1000]\n");
     printf("\tModeArgs = '-R +|x-y'\n");
	printf("\t\tCan specify a range of pkts to send; put only + to send all\n\n\n");

printf("'-h R' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}


doctor_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("Convert Mode\n");
printf("Usage: GPF <filein> <fileout> <ModeArgs>\n");
     printf("\tfilein = libpcap file to read in\n");
     printf("\tfileout = fileanme to output converted txt.gpf\n\n\n");

printf("'-h C' for this usage\n\n\n");
printf("NOTE: The EOL marker (\xef\xfe\xfe\xef) is for the perl parsing.  GPF doesn't need it when doing a replay.\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}


GPF_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("GPF mode (-G b|f|l|r)\n");
printf("Usage: GPF <CaptureFile> <type> <ReplayMode> <hostname/IP> <PORT> <TCP/UDP> <SEED> <DELAY> <LStart> <LStop> <PStart> <PStop> <AStart> <AInc> <AStop> <AChar> <PC> <UserFunc> <CycleMode> <ReadWait> <extraAttacks> <<AttackMode>>\n");
     printf("\tCaptureFile = File name of the captured traffic to replay [mycapture]\n");
     printf("\ttype = 0=txt.gpf; 1=libpcap (ethereal) [0]\n");
     printf("\tReplayMode = 0=Attack the server (act as client); 1=GPF listen for client connect, and then attack (act as sever) [0].\n");
     printf("\tIP = IP address of target; IP address to bind to [localhost]\n");
     printf("\tPORT = Destination port; Port to listen on [21]\n");
     printf("\tTCP/UDP = Protocol type [TCP]\n");
     printf("\tSEED = For repeatable randomness - Any string of numbers or letters (Allows a successful attack to be repeated) [82645286]\n");
     printf("\tDELAY = Any number of microseconds [1000]\n");
     printf("\tLStart = Decimal packet number (which 'leg' of the session) to begin fuzzing [0]\n");
     printf("\tLStop = Decimal packet number (which 'leg' of the session) to stop fuzzing [+]; +=all legs\n");
     printf("\tPStart = Decimal position in the data (if 40bytes of data, then 1-40;if>max skip leg) to begin fuzzing at [0]\n");
     printf("\tPStop = Decimal position in the data (if 40bytes of data, then 1-40) to stop fuzzing at [+]; +=max position\n");
     printf("\tAStart = Decimal sized number of bytes to start attacking with [0]\n");
     printf("\tAInc = Decimal size number of bytes to increment attack by [255]\n");
     printf("\tAStop = Decimal size number of bytes to stop at [17000]\n");
     printf("\tAChar = Hex character to fill attack buffer with. Use the from 41 for 'A', etc.\n");
	printf("\t\tIf AChar equal to 43, then fill with random data (for all three modes). [6e]\n");
     printf("\tPC = Print choice in which to display the session - 0=ascii; 1=hex; 2=auto [2]\n");
     printf("\tUserFunc = Name of user defined code.  Use 'none' if none [none].\n");
     printf("\tCycleMode = After each attack 0=close fd, and 1=finish replaying as much of capture file as possible. [1]\n");
     printf("\tReadWait = How many seconds to wait in a read if data is not availible. [3]\n");
     printf("\tExtraAttacks = Normal is 1 attackleg/session.  This option allows for multile attacklegs/session. [0]\n");
     printf("\tAttackMode Args = '-G r|b|f|l'  [-G b]\n");
	printf("\t\tr : Replay - For verification; no attack but can still use userFunc. Starts at LINE.\n");
	printf("\t\tb : Buffer overflow attack\n");
	printf("\t\tf : Format bug attack  (6e is n; a good choice when searching for format bugs)\n");
	printf("\t\tl : Logic (bit flipping) attack - AStart, Inc, Stop, and Char have special meaning - See README.\n");
            printf("\t\t\tUse AStart, AInc, and AStop to count how many times. POS and AChar have no meaning.\n\n\n");

printf("'-h G' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}

Pattern_GPF_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("Pattern (Tokenizer) GPF mode\n");
printf("Usage: GPF <CaptureFile> <type> <ReplayMode> <hostname/IP> <PORT> <TCP/UDP> <SEED> <DELAY> <PC> <UserFunc> <ReadWait> <delim> <delimLen> -P\n");
     printf("\tCaptureFile = File name of the captured traffic to replay [mycapture]\n");
     printf("\ttype = 0=txt.gpf; 1=libpcap (ethereal) [0]\n");
     printf("\tReplayMode = 0=Attack the server (act as client); 1=GPF listen for client connect, and then attack (act as sever) [0].\n");
     printf("\tIP = IP address of target; IP address to bind to[localhost]\n");
     printf("\tPORT = Destination port; Port to listen on[21]\n");
     printf("\tTCP/UDP = Protocol type [TCP]\n");
     printf("\tSEED = For repeatable randomness - Any string of numbers or letters (Allows a successful attack to be repeated) [82645286]\n");
     printf("\tDELAY = Any number of microseconds [2000]\n");
     printf("\tPC = Print choice in which to display the session - 0=ascii; 1=hex; 2=auto [2]\n");
     printf("\tUserFunc = Name of user defined code.  Use 'none' if none [none].\n");
     printf("\tReadWait = How many seconds to wait in a read if data is not availible. [3]\n");
     printf("\tdelim = is the delimeter between tokens. Use with quotes as " " for 0x20.\n");
     printf("\tdelimLen = is the length of that delimeter. 1 would be the length for 0x20.\n");
     printf("\t-P = Pattern Matching tokenizes each piece of each leg and inserts random attacks based on patterns.\n\n\n");

printf("'-h P' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}


main_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("'-h R' for pure fuzz usage\n");
printf("'-h C' for convert usage\n");
printf("'-h G' for GPF usage\n");
printf("'-h P' for the new Pattern Matching GPF usage\n");
printf("'-h' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}
