/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CmdLine is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*
 This file includes two fucntions for lib type use.
 This fucntions either setup a client or a server for protocol independant use 
 and returns a file(socket) descriptor 
 */
#include "headers.h"

int setup_client(struct addrinfo *server_info)
{
	int sockfd,i,b;

	/*Using the (possibly) multiple addrinfos, I now attempt to create and connect to a the
	server socket.  Each socket is given 7 trys before moving on to the next socket.  The first
	succesful connection is returned.
	*/	
	b=0;	
	do {
		sockfd = socket(server_info->ai_family, server_info->ai_socktype, server_info->ai_protocol);
		if (sockfd<0)
			continue;

		for(i=0;i<7;i++)
		{
			if(connect(sockfd, server_info->ai_addr, server_info->ai_addrlen) == 0)
			{
				//printf ("Client successfully contacted Server");
				b=1;
				break;
			}
			else
			{	
				perror("connect");
				printf ("Failed to setup client\n");
				printf ("Let's sleep for 1 second and try again....\n");
				sleep(1);
			}
			if(i==6)
			{
				printf ("Giving up!!\n");
			}
		}
		if(b=1)
			break;
	
		if( (close(sockfd) < 0))
		{
			perror("close");
		}

	} while ( (server_info = server_info->ai_next) != NULL);
	
	if (server_info == NULL)
	{
		printf("CLIENT SETUP ERROR!!!");
		return (-1);
	}

	return (sockfd);
}

int setup_server(struct addrinfo *server_address)
{

	int listenfd;

	do {
	/*Using the (possibly) multiple addrinfos, I now attempt to create, listen, and bind to 
	server socket.  The first succesful connection is returned.
	*/	
		listenfd = socket(server_address->ai_family, server_address->ai_socktype, server_address->ai_protocol);
		if (listenfd<0)
			continue;
		if (bind(listenfd, server_address->ai_addr, server_address->ai_addrlen) == 0)
			break;

		if( (close(listenfd) < 0))
		{
			perror("close listenfd");
		}
	} while ( (server_address = server_address->ai_next) != NULL);

	if(server_address == NULL)
	{	
		printf("SERVER SETUP ERROR!!!");
		return (-1);
	}
	
	if( server_address->ai_socktype==SOCK_STREAM )
	{
		if( (listen(listenfd, LISTENQ)) < 0)
		{
			perror("listen");
			return (-1);
		}
		return (listenfd);
	}
	else
	{
		return (listenfd);
	}
}
